var __decorate=this&&this.__decorate||function(e,t,r,s){var i,a=arguments.length,o=a<3?t:null===s?s=Object.getOwnPropertyDescriptor(t,r):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,r,s);else for(var n=e.length-1;n>=0;n--)(i=e[n])&&(o=(a<3?i(o):a>3?i(t,r,o):i(t,r))||o);return a>3&&o&&Object.defineProperty(t,r,o),o};import*as Host from"../../../core/host/host.js";import*as i18n from"../../../core/i18n/i18n.js";import*as Platform from"../../../core/platform/platform.js";import*as Buttons from"../../../ui/components/buttons/buttons.js";import*as LitHtml from"../../../ui/lit-html/lit-html.js";import*as Controllers from"../controllers/controllers.js";import*as Models from"../models/models.js";import*as Util from"../util/util.js";import{RecorderInput}from"./RecorderInput.js";import stepEditorStyles from"./stepEditor.css.js";import{ArrayAssignments,assert,deepFreeze,immutableDeepAssign,InsertAssignment}from"./util.js";const{html:html,Decorators:Decorators,Directives:Directives,LitElement:LitElement}=LitHtml,{customElement:customElement,property:property,state:state}=Decorators,{live:live}=Directives,typeConverters=Object.freeze({string:e=>e.trim(),number:e=>{const t=parseFloat(e);return Number.isNaN(t)?0:t},boolean:e=>"true"===e.toLowerCase()}),dataTypeByAttribute=Object.freeze({selectors:"string",offsetX:"number",offsetY:"number",target:"string",frame:"number",assertedEvents:"string",value:"string",key:"string",operator:"string",count:"number",expression:"string",x:"number",y:"number",url:"string",type:"string",timeout:"number",duration:"number",button:"string",deviceType:"string",width:"number",height:"number",deviceScaleFactor:"number",isMobile:"boolean",hasTouch:"boolean",isLandscape:"boolean",download:"number",upload:"number",latency:"number",name:"string",parameters:"string",visible:"boolean",properties:"string",attributes:"string"}),defaultValuesByAttribute=deepFreeze({selectors:[[".cls"]],offsetX:1,offsetY:1,target:"main",frame:[0],assertedEvents:[{type:"navigation",url:"https://example.com",title:"Title"}],value:"Value",key:"Enter",operator:">=",count:1,expression:"true",x:0,y:0,url:"https://example.com",timeout:5e3,duration:50,deviceType:"mouse",button:"primary",type:"click",width:800,height:600,deviceScaleFactor:1,isMobile:!1,hasTouch:!1,isLandscape:!0,download:1e3,upload:1e3,latency:25,name:"customParam",parameters:"{}",properties:"{}",attributes:[{name:"attribute",value:"value"}],visible:!0}),attributesByType=deepFreeze({[Models.Schema.StepType.Click]:{required:["selectors","offsetX","offsetY"],optional:["assertedEvents","button","deviceType","duration","frame","target","timeout"]},[Models.Schema.StepType.DoubleClick]:{required:["offsetX","offsetY","selectors"],optional:["assertedEvents","button","deviceType","frame","target","timeout"]},[Models.Schema.StepType.Hover]:{required:["selectors"],optional:["assertedEvents","frame","target","timeout"]},[Models.Schema.StepType.Change]:{required:["selectors","value"],optional:["assertedEvents","frame","target","timeout"]},[Models.Schema.StepType.KeyDown]:{required:["key"],optional:["assertedEvents","target","timeout"]},[Models.Schema.StepType.KeyUp]:{required:["key"],optional:["assertedEvents","target","timeout"]},[Models.Schema.StepType.Scroll]:{required:[],optional:["assertedEvents","frame","target","timeout","x","y"]},[Models.Schema.StepType.Close]:{required:[],optional:["assertedEvents","target","timeout"]},[Models.Schema.StepType.Navigate]:{required:["url"],optional:["assertedEvents","target","timeout"]},[Models.Schema.StepType.WaitForElement]:{required:["selectors"],optional:["assertedEvents","attributes","count","frame","operator","properties","target","timeout","visible"]},[Models.Schema.StepType.WaitForExpression]:{required:["expression"],optional:["assertedEvents","frame","target","timeout"]},[Models.Schema.StepType.CustomStep]:{required:["name","parameters"],optional:["assertedEvents","target","timeout"]},[Models.Schema.StepType.EmulateNetworkConditions]:{required:["download","latency","upload"],optional:["assertedEvents","target","timeout"]},[Models.Schema.StepType.SetViewport]:{required:["deviceScaleFactor","hasTouch","height","isLandscape","isMobile","width"],optional:["assertedEvents","target","timeout"]}}),UIStrings={notSaved:"Not saved: {error}",addAttribute:"Add {attributeName}",deleteRow:"Delete row",selectorPicker:"Select an element in the page to update selectors",addFrameIndex:"Add frame index within the frame tree",removeFrameIndex:"Remove frame index",addSelectorPart:"Add a selector part",removeSelectorPart:"Remove a selector part",addSelector:"Add a selector",removeSelector:"Remove a selector",unknownActionType:"Unknown action type."},str_=i18n.i18n.registerUIStrings("panels/recorder/components/StepEditor.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class StepEditedEvent extends Event{static eventName="stepedited";data;constructor(e){super(StepEditedEvent.eventName,{bubbles:!0,composed:!0}),this.data=e}}const cleanUndefineds=e=>JSON.parse(JSON.stringify(e));export class EditorState{static#e=new Util.SharedObject.SharedObject((()=>Models.RecordingPlayer.RecordingPlayer.connectPuppeteer()),(({browser:e})=>Models.RecordingPlayer.RecordingPlayer.disconnectPuppeteer(e)));static async default(e){const t={type:e},r=attributesByType[t.type];let s=Promise.resolve();for(const e of r.required)s=Promise.all([s,(async()=>Object.assign(t,{[e]:await this.defaultByAttribute(t,e)}))()]);return await s,Object.freeze(t)}static async defaultByAttribute(e,t){return this.#e.run((e=>{switch(t){case"assertedEvents":return immutableDeepAssign(defaultValuesByAttribute.assertedEvents,new ArrayAssignments({0:{url:e.page.url()||defaultValuesByAttribute.assertedEvents[0].url}}));case"url":return e.page.url()||defaultValuesByAttribute.url;case"height":return e.page.evaluate((()=>visualViewport.height))||defaultValuesByAttribute.height;case"width":return e.page.evaluate((()=>visualViewport.width))||defaultValuesByAttribute.width;default:return defaultValuesByAttribute[t]}}))}static fromStep(e){const t=structuredClone(e);for(const r of["parameters","properties"])r in e&&void 0!==e[r]&&(t[r]=JSON.stringify(e[r]));if("attributes"in e&&e.attributes){t.attributes=[];for(const[r,s]of Object.entries(e.attributes))t.attributes.push({name:r,value:s})}return"selectors"in e&&(t.selectors=e.selectors.map((e=>"string"==typeof e?[e]:[...e]))),deepFreeze(t)}static toStep(e){const t=structuredClone(e);for(const r of["parameters","properties"]){const s=e[r];s&&Object.assign(t,{[r]:JSON.parse(s)})}if(e.attributes)if(0!==e.attributes.length){const r={};for(const{name:t,value:s}of e.attributes)Object.assign(r,{[t]:s});Object.assign(t,{attributes:r})}else"attributes"in t&&delete t.attributes;if(e.selectors){const r=e.selectors.filter((e=>e.length>0)).map((e=>1===e.length?e[0]:[...e]));0!==r.length?Object.assign(t,{selectors:r}):"selectors"in t&&delete t.selectors}return e.frame&&0===e.frame.length&&"frame"in t&&delete t.frame,r=Models.SchemaUtils.parseStep(t),JSON.parse(JSON.stringify(r));var r}}let RecorderSelectorPickerButton=class extends LitElement{static styles=[stepEditorStyles];#t=new Controllers.SelectorPicker.SelectorPicker(this);constructor(){super(),this.disabled=!1}#r=e=>{e.preventDefault(),e.stopPropagation(),this.#t.toggle()};disconnectedCallback(){super.disconnectedCallback(),this.#t.stop()}render(){if(!this.disabled)return html`<devtools-button
      @click=${this.#r}
      .title=${i18nString(UIStrings.selectorPicker)}
      class="selector-picker"
      .size=${"SMALL"}
      .iconName=${"select-element"}
      .active=${this.#t.active}
      .variant=${"secondary"}
    ></devtools-button>`}};__decorate([property()],RecorderSelectorPickerButton.prototype,"disabled",void 0),RecorderSelectorPickerButton=__decorate([customElement("devtools-recorder-selector-picker-button")],RecorderSelectorPickerButton);export let StepEditor=class extends LitElement{static styles=[stepEditorStyles];#s=new Set;constructor(){super(),this.state={type:Models.Schema.StepType.WaitForElement},this.isTypeEditable=!0,this.disabled=!1}createRenderRoot(){const e=super.createRenderRoot();return e.addEventListener("keydown",this.#i),e}set step(e){this.state=deepFreeze(EditorState.fromStep(e)),this.error=void 0}#a(e){try{this.dispatchEvent(new StepEditedEvent(EditorState.toStep(e))),this.state=e}catch(e){this.error=e.message}}#o=e=>{e.preventDefault(),e.stopPropagation(),this.#a(immutableDeepAssign(this.state,{target:e.data.target,frame:e.data.frame,selectors:e.data.selectors.map((e=>"string"==typeof e?[e]:e)),offsetX:e.data.offsetX,offsetY:e.data.offsetY}))};#n=(e,t,r)=>s=>{s.preventDefault(),s.stopPropagation(),this.#a(immutableDeepAssign(this.state,e)),this.#d(t),r&&Host.userMetrics.recordingEdited(r)};#i=e=>{if(assert(e instanceof KeyboardEvent),e.target instanceof RecorderInput&&"Enter"===e.key){e.preventDefault(),e.stopPropagation();const t=this.renderRoot.querySelectorAll("devtools-recorder-input"),r=[...t].findIndex((t=>t===e.target));r>=0&&r+1<t.length?t[r+1].focus():e.target.blur()}};#l=e=>t=>{if(assert(t.target instanceof RecorderInput),t.target.disabled)return;const r=dataTypeByAttribute[e.attribute],s=typeConverters[r](t.target.value),i=e.from.bind(this)(s);i&&(this.#a(immutableDeepAssign(this.state,i)),e.metric&&Host.userMetrics.recordingEdited(e.metric))};#c=async e=>{if(assert(e.target instanceof RecorderInput),e.target.disabled)return;const t=e.target.value;t!==this.state.type&&(Object.values(Models.Schema.StepType).includes(t)?(this.#a(await EditorState.default(t)),Host.userMetrics.recordingEdited(Host.UserMetrics.RecordingEdited.TypeChanged)):this.error=i18nString(UIStrings.unknownActionType))};#u=async e=>{e.preventDefault(),e.stopPropagation();const t=e.target.dataset.attribute;this.#a(immutableDeepAssign(this.state,{[t]:await EditorState.defaultByAttribute(this.state,t)})),this.#d(`[data-attribute=${t}].attribute devtools-recorder-input`)};#p(e){if(!this.disabled)return html`
      <devtools-button
        title=${e.title}
        .size=${"SMALL"}
        .iconName=${e.iconName}
        .variant=${"secondary"}
        class="inline-button ${e.class}"
        @click=${e.onClick}
      ></devtools-button>
    `}#m(e){if(this.disabled)return;return[...attributesByType[this.state.type].optional].includes(e)&&!this.disabled?html`<devtools-button
      .size=${"SMALL"}
      .iconName=${"bin"}
      .variant=${"secondary"}
      .title=${i18nString(UIStrings.deleteRow)}
      class="inline-button delete-row"
      data-attribute=${e}
      @click=${t=>{t.preventDefault(),t.stopPropagation(),this.#a(immutableDeepAssign(this.state,{[e]:void 0}))}}
    ></devtools-button>`:void 0}#h(e){return this.#s.add("type"),html`<div class="row attribute" data-attribute="type">
      <div>type<span class="separator">:</span></div>
      <devtools-recorder-input
        .disabled=${!e||this.disabled}
        .options=${Object.values(Models.Schema.StepType)}
        .placeholder=${defaultValuesByAttribute.type}
        .value=${live(this.state.type)}
        @blur=${this.#c}
      ></devtools-recorder-input>
    </div>`}#v(e){this.#s.add(e);const t=this.state[e]?.toString();if(void 0!==t)return html`<div class="row attribute" data-attribute=${e}>
      <div>${e}<span class="separator">:</span></div>
      <devtools-recorder-input
        .disabled=${this.disabled}
        .placeholder=${defaultValuesByAttribute[e].toString()}
        .value=${live(t)}
        .mimeType=${(()=>{switch(e){case"expression":return"text/javascript";case"properties":return"application/json";default:return""}})()}
        @blur=${this.#l({attribute:e,from(t){if(void 0!==this.state[e]){if("properties"===e)Host.userMetrics.recordingAssertion(Host.UserMetrics.RecordingAssertion.PropertyAssertionEdited);return{[e]:t}}},metric:Host.UserMetrics.RecordingEdited.OtherEditing})}
      ></devtools-recorder-input>
      ${this.#m(e)}
    </div>`}#b(){if(this.#s.add("frame"),void 0!==this.state.frame)return html`
      <div class="attribute" data-attribute="frame">
        <div class="row">
          <div>frame<span class="separator">:</span></div>
          ${this.#m("frame")}
        </div>
        ${this.state.frame.map(((e,t,r)=>html`
            <div class="padded row">
              <devtools-recorder-input
                .disabled=${this.disabled}
                .placeholder=${defaultValuesByAttribute.frame[0].toString()}
                .value=${live(e.toString())}
                data-path=${`frame.${t}`}
                @blur=${this.#l({attribute:"frame",from(e){if(void 0!==this.state.frame?.[t])return{frame:new ArrayAssignments({[t]:e})}},metric:Host.UserMetrics.RecordingEdited.OtherEditing})}
              ></devtools-recorder-input>
              ${this.#p({class:"add-frame",title:i18nString(UIStrings.addFrameIndex),iconName:"plus",onClick:this.#n({frame:new ArrayAssignments({[t+1]:new InsertAssignment(defaultValuesByAttribute.frame[0])})},`devtools-recorder-input[data-path="frame.${t+1}"]`,Host.UserMetrics.RecordingEdited.OtherEditing)})}
              ${this.#p({class:"remove-frame",title:i18nString(UIStrings.removeFrameIndex),iconName:"minus",onClick:this.#n({frame:new ArrayAssignments({[t]:void 0})},`devtools-recorder-input[data-path="frame.${Math.min(t,r.length-2)}"]`,Host.UserMetrics.RecordingEdited.OtherEditing)})}
            </div>
          `))}
      </div>
    `}#g(){if(this.#s.add("selectors"),void 0!==this.state.selectors)return html`<div class="attribute" data-attribute="selectors">
      <div class="row">
        <div>selectors<span class="separator">:</span></div>
        <devtools-recorder-selector-picker-button
          @selectorpicked=${this.#o}
          .disabled=${this.disabled}
        ></devtools-recorder-selector-picker-button>
        ${this.#m("selectors")}
      </div>
      ${this.state.selectors.map(((e,t,r)=>html`<div class="padded row" data-selector-path=${t}>
            <div>selector #${t+1}<span class="separator">:</span></div>
            ${this.#p({class:"add-selector",title:i18nString(UIStrings.addSelector),iconName:"plus",onClick:this.#n({selectors:new ArrayAssignments({[t+1]:new InsertAssignment(structuredClone(defaultValuesByAttribute.selectors[0]))})},`devtools-recorder-input[data-path="selectors.${t+1}.0"]`,Host.UserMetrics.RecordingEdited.SelectorAdded)})}
            ${this.#p({class:"remove-selector",title:i18nString(UIStrings.removeSelector),iconName:"minus",onClick:this.#n({selectors:new ArrayAssignments({[t]:void 0})},`devtools-recorder-input[data-path="selectors.${Math.min(t,r.length-2)}.0"]`,Host.UserMetrics.RecordingEdited.SelectorRemoved)})}
          </div>
          ${e.map(((e,r,s)=>html`<div
              class="double padded row"
              data-selector-path="${t}.${r}"
            >
              <devtools-recorder-input
                .disabled=${this.disabled}
                .placeholder=${defaultValuesByAttribute.selectors[0][0]}
                .value=${live(e)}
                data-path=${`selectors.${t}.${r}`}
                @blur=${this.#l({attribute:"selectors",from(e){if(void 0!==this.state.selectors?.[t]?.[r])return{selectors:new ArrayAssignments({[t]:new ArrayAssignments({[r]:e})})}},metric:Host.UserMetrics.RecordingEdited.SelectorPartEdited})}
              ></devtools-recorder-input>
              ${this.#p({class:"add-selector-part",title:i18nString(UIStrings.addSelectorPart),iconName:"plus",onClick:this.#n({selectors:new ArrayAssignments({[t]:new ArrayAssignments({[r+1]:new InsertAssignment(defaultValuesByAttribute.selectors[0][0])})})},`devtools-recorder-input[data-path="selectors.${t}.${r+1}"]`,Host.UserMetrics.RecordingEdited.SelectorPartAdded)})}
              ${this.#p({class:"remove-selector-part",title:i18nString(UIStrings.removeSelectorPart),iconName:"minus",onClick:this.#n({selectors:new ArrayAssignments({[t]:new ArrayAssignments({[r]:void 0})})},`devtools-recorder-input[data-path="selectors.${t}.${Math.min(r,s.length-2)}"]`,Host.UserMetrics.RecordingEdited.SelectorPartRemoved)})}
            </div>`))}`))}
    </div>`}#f(){if(this.#s.add("assertedEvents"),void 0!==this.state.assertedEvents)return html`<div class="attribute" data-attribute="assertedEvents">
      <div class="row">
        <div>asserted events<span class="separator">:</span></div>
        ${this.#m("assertedEvents")}
      </div>
      ${this.state.assertedEvents.map(((e,t)=>html` <div class="padded row">
            <div>type<span class="separator">:</span></div>
            <div>${e.type}</div>
          </div>
          <div class="padded row">
            <div>title<span class="separator">:</span></div>
            <devtools-recorder-input
              .disabled=${this.disabled}
              .placeholder=${defaultValuesByAttribute.assertedEvents[0].title}
              .value=${live(e.title??"")}
              @blur=${this.#l({attribute:"assertedEvents",from(e){if(void 0!==this.state.assertedEvents?.[t]?.title)return{assertedEvents:new ArrayAssignments({[t]:{title:e}})}},metric:Host.UserMetrics.RecordingEdited.OtherEditing})}
            ></devtools-recorder-input>
          </div>
          <div class="padded row">
            <div>url<span class="separator">:</span></div>
            <devtools-recorder-input
              .disabled=${this.disabled}
              .placeholder=${defaultValuesByAttribute.assertedEvents[0].url}
              .value=${live(e.url??"")}
              @blur=${this.#l({attribute:"url",from(e){if(void 0!==this.state.assertedEvents?.[t]?.url)return{assertedEvents:new ArrayAssignments({[t]:{url:e}})}},metric:Host.UserMetrics.RecordingEdited.OtherEditing})}
            ></devtools-recorder-input>
          </div>`))}
    </div> `}#y(){if(this.#s.add("attributes"),void 0!==this.state.attributes)return html`<div class="attribute" data-attribute="attributes">
      <div class="row">
        <div>attributes<span class="separator">:</span></div>
        ${this.#m("attributes")}
      </div>
      ${this.state.attributes.map((({name:e,value:t},r,s)=>html`<div class="padded row">
          <devtools-recorder-input
            .disabled=${this.disabled}
            .placeholder=${defaultValuesByAttribute.attributes[0].name}
            .value=${live(e)}
            data-path=${`attributes.${r}.name`}
            @blur=${this.#l({attribute:"attributes",from(e){if(void 0!==this.state.attributes?.[r]?.name)return Host.userMetrics.recordingAssertion(Host.UserMetrics.RecordingAssertion.AttributeAssertionEdited),{attributes:new ArrayAssignments({[r]:{name:e}})}},metric:Host.UserMetrics.RecordingEdited.OtherEditing})}
          ></devtools-recorder-input>
          <span class="separator">:</span>
          <devtools-recorder-input
            .disabled=${this.disabled}
            .placeholder=${defaultValuesByAttribute.attributes[0].value}
            .value=${live(t)}
            data-path=${`attributes.${r}.value`}
            @blur=${this.#l({attribute:"attributes",from(e){if(void 0!==this.state.attributes?.[r]?.value)return Host.userMetrics.recordingAssertion(Host.UserMetrics.RecordingAssertion.AttributeAssertionEdited),{attributes:new ArrayAssignments({[r]:{value:e}})}},metric:Host.UserMetrics.RecordingEdited.OtherEditing})}
          ></devtools-recorder-input>
          ${this.#p({class:"add-attribute-assertion",title:i18nString(UIStrings.addSelectorPart),iconName:"plus",onClick:this.#n({attributes:new ArrayAssignments({[r+1]:new InsertAssignment((()=>{{const e=new Set(s.map((({name:e})=>e))),t=defaultValuesByAttribute.attributes[0];let r=t.name,i=0;for(;e.has(r);)++i,r=`${t.name}-${i}`;return{...t,name:r}}})())})},`devtools-recorder-input[data-path="attributes.${r+1}.name"]`,Host.UserMetrics.RecordingEdited.OtherEditing)})}
          ${this.#p({class:"remove-attribute-assertion",title:i18nString(UIStrings.removeSelectorPart),iconName:"minus",onClick:this.#n({attributes:new ArrayAssignments({[r]:void 0})},`devtools-recorder-input[data-path="attributes.${Math.min(r,s.length-2)}.value"]`,Host.UserMetrics.RecordingEdited.OtherEditing)})}
        </div>`))}
    </div>`}#S(){return[...attributesByType[this.state.type].optional].filter((e=>void 0===this.state[e])).map((e=>html`<devtools-button
          .variant=${"secondary"}
          class="add-row"
          data-attribute=${e}
          @click=${this.#u}
        >
          ${i18nString(UIStrings.addAttribute,{attributeName:e})}
        </devtools-button>`))}#d=e=>{this.updateComplete.then((()=>{const t=this.renderRoot.querySelector(e);t?.focus()}))};render(){this.#s=new Set;const e=html`
      <div class="wrapper">
        ${this.#h(this.isTypeEditable)} ${this.#v("target")}
        ${this.#b()} ${this.#g()}
        ${this.#v("deviceType")} ${this.#v("button")}
        ${this.#v("url")} ${this.#v("x")}
        ${this.#v("y")} ${this.#v("offsetX")}
        ${this.#v("offsetY")} ${this.#v("value")}
        ${this.#v("key")} ${this.#v("operator")}
        ${this.#v("count")} ${this.#v("expression")}
        ${this.#v("duration")} ${this.#f()}
        ${this.#v("timeout")} ${this.#v("width")}
        ${this.#v("height")} ${this.#v("deviceScaleFactor")}
        ${this.#v("isMobile")} ${this.#v("hasTouch")}
        ${this.#v("isLandscape")} ${this.#v("download")}
        ${this.#v("upload")} ${this.#v("latency")}
        ${this.#v("name")} ${this.#v("parameters")}
        ${this.#v("visible")} ${this.#v("properties")}
        ${this.#y()}
        ${this.error?html`
              <div class="error">
                ${i18nString(UIStrings.notSaved,{error:this.error})}
              </div>
            `:void 0}
        ${this.disabled?void 0:html`<div
              class="row-buttons wrapped gap row regular-font no-margin"
            >
              ${this.#S()}
            </div>`}
      </div>
    `;return Platform.DCHECK((()=>{for(const e of Object.keys(dataTypeByAttribute))if(!this.#s.has(e))return!1;return!0}),"One of the editable attributes does not have UI"),e}};__decorate([state()],StepEditor.prototype,"state",void 0),__decorate([state()],StepEditor.prototype,"error",void 0),__decorate([property()],StepEditor.prototype,"isTypeEditable",void 0),__decorate([property()],StepEditor.prototype,"disabled",void 0),StepEditor=__decorate([customElement("devtools-recorder-step-editor")],StepEditor);