import*as Common from"../../core/common/common.js";import*as i18n from"../../core/i18n/i18n.js";import*as SDK from"../../core/sdk/sdk.js";import*as ObjectUI from"../../ui/legacy/components/object_ui/object_ui.js";import objectValueStyles from"../../ui/legacy/components/object_ui/objectValue.css.js";import*as Components from"../../ui/legacy/components/utils/utils.js";import*as UI from"../../ui/legacy/legacy.js";import eventListenersViewStyles from"./eventListenersView.css.js";import{frameworkEventListeners}from"./EventListenersUtils.js";const UIStrings={noEventListeners:"No event listeners",remove:"Remove",deleteEventListener:"Delete event listener",togglePassive:"Toggle Passive",toggleWhetherEventListenerIs:"Toggle whether event listener is passive or blocking",revealInElementsPanel:"Reveal in Elements panel",passive:"Passive"},str_=i18n.i18n.registerUIStrings("panels/event_listeners/EventListenersView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class EventListenersView extends UI.Widget.VBox{changeCallback;enableDefaultTreeFocus;treeOutline;emptyHolder;linkifier;treeItemMap;constructor(e,t=!1){super(),this.changeCallback=e,this.enableDefaultTreeFocus=t,this.treeOutline=new UI.TreeOutline.TreeOutlineInShadow,this.treeOutline.setComparator(EventListenersTreeElement.comparator),this.treeOutline.element.classList.add("monospace"),this.treeOutline.setShowSelectionOnKeyboardFocus(!0),this.treeOutline.setFocusable(!0),this.element.appendChild(this.treeOutline.element),this.emptyHolder=document.createElement("div"),this.emptyHolder.classList.add("gray-info-message"),this.emptyHolder.textContent=i18nString(UIStrings.noEventListeners),this.emptyHolder.tabIndex=-1,this.linkifier=new Components.Linkifier.Linkifier,this.treeItemMap=new Map}focus(){this.enableDefaultTreeFocus&&(this.emptyHolder.parentNode?this.emptyHolder.focus():this.treeOutline.forceSelect())}async addObjects(e){this.reset(),await Promise.all(e.map((e=>e?this.addObject(e):Promise.resolve()))),this.addEmptyHolderIfNeeded(),this.eventListenersArrivedForTest()}addObject(e){let t,n=null;const i=[],s=e.runtimeModel().target().model(SDK.DOMDebuggerModel.DOMDebuggerModel);return s&&i.push(s.eventListeners(e).then((function(e){t=e}))),i.push(frameworkEventListeners(e).then((function(e){n=e}))),Promise.all(i).then((async function(){if(!n)return;if(!n.internalHandlers)return;return n.internalHandlers.object().callFunctionJSON((function(){const e=[],t=new Set(this);for(const n of arguments)e.push(t.has(n));return e}),t.map((function(e){return SDK.RemoteObject.RemoteObject.toCallArgument(e.handler())}))).then((function(e){for(let n=0;n<t.length;++n)e[n]&&t[n].markAsFramework()}))})).then(function(){this.addObjectEventListeners(e,t),n&&this.addObjectEventListeners(e,n.eventListeners)}.bind(this))}addObjectEventListeners(e,t){if(t)for(const n of t){this.getOrCreateTreeElementForType(n.type()).addObjectEventListener(n,e)}}showFrameworkListeners(e,t,n){const i=this.treeOutline.rootElement().children();for(const s of i){let i=!0;for(const r of s.children()){const s=r,l=s.eventListener().origin();let o=!1;l!==SDK.DOMDebuggerModel.EventListener.Origin.FrameworkUser||e||(o=!0),l===SDK.DOMDebuggerModel.EventListener.Origin.Framework&&e&&(o=!0),!t&&s.eventListener().passive()&&(o=!0),n||s.eventListener().passive()||(o=!0),s.hidden=o,i=i&&o}s.hidden=i}}getOrCreateTreeElementForType(e){let t=this.treeItemMap.get(e);return t||(t=new EventListenersTreeElement(e,this.linkifier,this.changeCallback),this.treeItemMap.set(e,t),t.hidden=!0,this.treeOutline.appendChild(t)),this.emptyHolder.remove(),t}addEmptyHolderIfNeeded(){let e=!0,t=null;for(const n of this.treeOutline.rootElement().children())n.hidden=!n.firstChild(),e=e&&n.hidden,t||n.hidden||(t=n);e&&!this.emptyHolder.parentNode&&this.element.appendChild(this.emptyHolder),t&&t.select(!0),this.treeOutline.setFocusable(Boolean(t))}reset(){const e=this.treeOutline.rootElement().children();for(const t of e)t.removeChildren();this.linkifier.reset()}eventListenersArrivedForTest(){}wasShown(){super.wasShown(),this.treeOutline.registerCSSFiles([eventListenersViewStyles,objectValueStyles])}}export class EventListenersTreeElement extends UI.TreeOutline.TreeElement{toggleOnClick;linkifier;changeCallback;constructor(e,t,n){super(e),this.toggleOnClick=!0,this.linkifier=t,this.changeCallback=n,UI.ARIAUtils.setLabel(this.listItemElement,`${e}, event listener`)}static comparator(e,t){return e.title===t.title?0:e.title>t.title?1:-1}addObjectEventListener(e,t){const n=new ObjectEventListenerBar(e,t,this.linkifier,this.changeCallback);this.appendChild(n)}}export class ObjectEventListenerBar extends UI.TreeOutline.TreeElement{eventListenerInternal;editable;changeCallback;valueTitle;constructor(e,t,n,i){super("",!0),this.eventListenerInternal=e,this.editable=!1,this.setTitle(t,n),this.changeCallback=i}async onpopulate(){const e=[],t=this.eventListenerInternal,n=t.domDebuggerModel().runtimeModel();e.push(n.createRemotePropertyFromPrimitiveValue("useCapture",t.useCapture())),e.push(n.createRemotePropertyFromPrimitiveValue("passive",t.passive())),e.push(n.createRemotePropertyFromPrimitiveValue("once",t.once())),void 0!==t.handler()&&e.push(new SDK.RemoteObject.RemoteObjectProperty("handler",t.handler())),ObjectUI.ObjectPropertiesSection.ObjectPropertyTreeElement.populateWithProperties(this,e,[],!0,!0,null)}setTitle(e,t){const n=this.listItemElement.createChild("span","event-listener-details"),i=ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection.createPropertyValue(e,!1,!1);if(this.valueTitle=i.element,n.appendChild(this.valueTitle),this.eventListenerInternal.canRemove()){const e=n.createChild("span","event-listener-button");e.textContent=i18nString(UIStrings.remove),UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.deleteEventListener)),e.addEventListener("click",(e=>{this.removeListener(),e.consume()}),!1),n.appendChild(e)}if(this.eventListenerInternal.isScrollBlockingType()&&this.eventListenerInternal.canTogglePassive()){const e=n.createChild("span","event-listener-button");e.textContent=i18nString(UIStrings.togglePassive),UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.toggleWhetherEventListenerIs)),e.addEventListener("click",(e=>{this.togglePassiveListener(),e.consume()}),!1),n.appendChild(e)}const s=n.createChild("span","event-listener-tree-subtitle"),r=t.linkifyRawLocation(this.eventListenerInternal.location(),this.eventListenerInternal.sourceURL());s.appendChild(r),this.listItemElement.addEventListener("contextmenu",(t=>{const n=new UI.ContextMenu.ContextMenu(t);t.target!==r&&n.appendApplicableItems(r),"node"===e.subtype&&n.defaultSection().appendItem(i18nString(UIStrings.revealInElementsPanel),(()=>Common.Revealer.reveal(e))),n.defaultSection().appendItem(i18nString(UIStrings.deleteEventListener),this.removeListener.bind(this),!this.eventListenerInternal.canRemove()),n.defaultSection().appendCheckboxItem(i18nString(UIStrings.passive),this.togglePassiveListener.bind(this),this.eventListenerInternal.passive(),!this.eventListenerInternal.canTogglePassive()),n.show()}))}removeListener(){this.removeListenerBar(),this.eventListenerInternal.remove()}togglePassiveListener(){this.eventListenerInternal.togglePassive().then((()=>this.changeCallback()))}removeListenerBar(){const e=this.parent;if(!e)return;e.removeChild(this),e.childCount()||e.collapse();let t=!0;for(const n of e.children())n.hidden||(t=!1);e.hidden=t}eventListener(){return this.eventListenerInternal}onenter(){return!!this.valueTitle&&(this.valueTitle.click(),!0)}ondelete(){return!!this.eventListenerInternal.canRemove()&&(this.removeListener(),!0)}}