import*as Common from"../../../core/common/common.js";import*as Platform from"../../../core/platform/platform.js";import*as SDK from"../../../core/sdk/sdk.js";import*as UI from"../../../ui/legacy/legacy.js";import*as Util from"../util/util.js";import{AssertedEventType,StepType}from"./Schema.js";import{areSelectorsEqual,createEmulateNetworkConditionsStep,createViewportStep}from"./SchemaUtils.js";import{evaluateInAllFrames,getTargetFrameContext}from"./SDKUtils.js";const formatAsJSLiteral=Platform.StringUtilities.formatAsJSLiteral,unrelatedNavigationTypes=new Set(["typed","address_bar","auto_bookmark","auto_subframe","generated","auto_toplevel","reload","keyword","keyword_generated"]),createShortcuts=e=>{const t=[];for(const r of e)for(const e of r){const r={meta:!1,ctrl:!1,shift:!1,alt:!1,keyCode:-1},{keyCode:a,modifiers:s}=UI.KeyboardShortcut.KeyboardShortcut.keyCodeAndModifiersFromKey(e);r.keyCode=a;const i=UI.KeyboardShortcut.Modifiers;r.ctrl=Boolean(s&i.Ctrl),r.meta=Boolean(s&i.Meta),r.shift=Boolean(s&i.Shift),r.shift=Boolean(s&i.Alt),-1!==r.keyCode&&t.push(r)}return t},evaluateInAllTargets=async(e,t,r)=>{await Promise.all(t.map((t=>evaluateInAllFrames(e,t,r))))},RecorderBinding=Object.freeze({addStep:"addStep",stopShortcut:"stopShortcut"});export class RecordingSession extends Common.ObjectWrapper.ObjectWrapper{#e;#t;#r;#a;#s;#i=new Map;#n=new Map;#o=new Map;#d=new Map;#l=new Map;#g=new Map;#c=new Common.Mutex.Mutex;#p;#h=new Map;#u=!1;#v=[];constructor(e,t){super(),this.#e=e,this.#t=e.pageAgent(),this.#r=e.targetAgent(),this.#a=SDK.NetworkManager.MultitargetNetworkManager.instance();const r=e.model(SDK.ResourceTreeModel.ResourceTreeModel);if(!r)throw new Error("ResourceTreeModel is missing for the target: "+e.id());this.#s=r,this.#e=e,this.#p={title:t.title,selectorAttribute:t.selectorAttribute,steps:[]},this.#v=t.selectorTypesToRecord}cloneUserFlow(){return structuredClone(this.#p)}overwriteUserFlow(e){this.#p=structuredClone(e)}async start(){if(this.#u)throw new Error("The session has started");this.#u=!0,await this.#t.invoke_setPrerenderingAllowed({isAllowed:!1}),this.#a.addEventListener(SDK.NetworkManager.MultitargetNetworkManager.Events.ConditionsChanged,this.#m,this),await this.#y(),await this.#t.invoke_bringToFront(),await this.#w(this.#e)}async stop(){await this.#t.invoke_setPrerenderingAllowed({isAllowed:!0}),await this.#f(),this.#c.acquire(),await Promise.all([...this.#i.values()].map(this.#T)),this.#a.removeEventListener(SDK.NetworkManager.MultitargetNetworkManager.Events.ConditionsChanged,this.#m,this)}async#y(){const e=this.#s.mainFrame;if(!e)throw new Error("Could not find mainFrame.");this.#a.networkConditions()!==SDK.NetworkManager.NoThrottlingConditions&&this.#m();const{cssLayoutViewport:t}=await this.#e.pageAgent().invoke_getLayoutMetrics();this.#S(createViewportStep(t));const r=await this.#s.navigationHistory();if(r){const e=r.entries[r.currentIndex];this.#n.set(this.#e.id(),e.id),this.#o.set(this.#e.id(),r.entries.map((e=>e.id))),this.#p.steps.push({type:StepType.Navigate,url:e.url,assertedEvents:[{type:AssertedEventType.Navigation,url:e.url,title:e.title}]})}else this.#p.steps.push({type:StepType.Navigate,url:e.url,assertedEvents:[{type:AssertedEventType.Navigation,url:e.url,title:await this.#E(this.#e)}]});this.#f()}async#E(e){const t=await e.runtimeAgent().invoke_evaluate({expression:"document.title"});return t.result?.value||""}#m(){const e=this.#a.networkConditions();this.#S(createEmulateNetworkConditionsStep(e))}#C;#k=[];#f(){return this.#C&&clearTimeout(this.#C),this.#C=setTimeout((()=>{this.dispatchEventToListeners("recordingupdated",structuredClone(this.#p)),this.#C=void 0;for(const e of this.#k)e();this.#k.length=0}),100),new Promise((e=>{this.#k.push(e)}))}get#N(){return this.#p.steps.slice(-1)[0]}#M=new Set;#S(e){switch(e.type){case"doubleClick":for(let t=this.#p.steps.length-1;t>0;t--){const r=this.#p.steps[t];if("click"===r.type){e.selectors=r.selectors,this.#p.steps.splice(t,1);break}}break;case"change":{const t=this.#N;if(!t)break;switch(t.type){case"change":if(!areSelectorsEqual(e,t))break;return this.#p.steps[this.#p.steps.length-1]=e,void this.#f();case"keyDown":return this.#M.add(t.key),this.#p.steps.pop(),void this.#S(e)}break}case"keyDown":if(this.#M.has(e.key))return;break;case"keyUp":if(this.#M.has(e.key))return void this.#M.delete(e.key)}this.#p.steps.push(e),this.#f()}#D(e,t){const r=this.#p.steps[this.#p.steps.length-1];if(r&&!r.assertedEvents?.find((e=>e.type===AssertedEventType.Navigation))){const a=e.target||"main",s=(e.frame||[]).join(","),i=r.target||"main",n=(("frame"in r?r.frame:[])||[]).join(",");a===i&&s===n&&(r.assertedEvents=[{type:AssertedEventType.Navigation}],this.#h.set(t.id(),r),this.#f())}}#A(e,t){const r=this.#h.get(e.id());if(!r)return;const a=r;if(!a.assertedEvents)return;const s=a.assertedEvents.find((e=>e.type===AssertedEventType.Navigation));s&&!s.url&&(s.url=t.url,s.title=t.title,this.#f())}#R(e){const t=Number(e.data.payload);for(let e=0;e<t-1;e++)this.#p.steps.pop();this.dispatchEventToListeners("recordingstopped",structuredClone(this.#p))}#b(e,t){switch(t.data.name){case RecorderBinding.stopShortcut:return void this.#R(t);case RecorderBinding.addStep:return void this.#U(e,t);default:return}}#U(e,t){const r=t.data.executionContextId;let a;const s=e.model(SDK.RuntimeModel.RuntimeModel);if(s)for(const e of s.executionContexts())if(e.id===r){a=e.frameId;break}if(!a)throw new Error("No execution context found for the binding call + "+JSON.stringify(t.data));const i=JSON.parse(t.data.payload),n=e.model(SDK.ResourceTreeModel.ResourceTreeModel).frameForId(a);if(!n)throw new Error("Could not find frame.");const o=getTargetFrameContext(e,n);if("beforeUnload"!==i.type)switch(i.type){case"change":this.#S({type:"change",value:i.value,selectors:i.selectors,frame:o.frame.length?o.frame:void 0,target:o.target});break;case"doubleClick":this.#S({type:"doubleClick",target:o.target,selectors:i.selectors,offsetY:i.offsetY,offsetX:i.offsetX,frame:o.frame.length?o.frame:void 0,deviceType:i.deviceType,button:i.button});break;case"click":this.#S({type:"click",target:o.target,selectors:i.selectors,offsetY:i.offsetY,offsetX:i.offsetX,frame:o.frame.length?o.frame:void 0,duration:i.duration,deviceType:i.deviceType,button:i.button});break;case"keyUp":this.#S({type:"keyUp",key:i.key,frame:o.frame.length?o.frame:void 0,target:o.target});break;case"keyDown":this.#S({type:"keyDown",frame:o.frame.length?o.frame:void 0,target:o.target,key:i.key});break;default:throw new Error("Unhandled client event")}else this.#D(o,e)}#I(){const e=UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutsForAction("chrome_recorder.start-recording").map((e=>e.descriptors.map((e=>e.key))));return createShortcuts(e)}static get#B(){try{return Common.Settings.Settings.instance().settingForTest("untrustedRecorderEvents"),!0}catch{}return!1}#w=async e=>{if(e.type()!==SDK.Target.Type.Frame)return;this.#i.set(e.id(),e);const t=e.model(SDK.AccessibilityModel.AccessibilityModel);Platform.assertNotNullOrUndefined(t),await t.resumeModel(),await this.#F(e),await this.#O(e);const r=e.model(SDK.ChildTargetManager.ChildTargetManager);Platform.assertNotNullOrUndefined(r),this.#g.set(e,[r.addEventListener(SDK.ChildTargetManager.Events.TargetCreated,this.#L.bind(this,e)),r.addEventListener(SDK.ChildTargetManager.Events.TargetDestroyed,this.#K.bind(this,e)),r.addEventListener(SDK.ChildTargetManager.Events.TargetInfoChanged,this.#P.bind(this,e))]),await Promise.all(r.childTargets().map(this.#w))};#T=async e=>{const t=this.#g.get(e);t&&Common.EventTarget.removeEventListeners(t),await this.#_(e),await this.#j(e)};async#F(e){const t=e.model(SDK.RuntimeModel.RuntimeModel);Platform.assertNotNullOrUndefined(t),this.#l.set(e,[t.addEventListener(SDK.RuntimeModel.Events.BindingCalled,this.#b.bind(this,e))]),await Promise.all(Object.values(RecorderBinding).map((e=>t.addBinding({name:e,executionContextName:Util.DEVTOOLS_RECORDER_WORLD_NAME}))))}async#j(e){await Promise.all(Object.values(RecorderBinding).map((t=>e.runtimeAgent().invoke_removeBinding({name:t}))));const t=this.#l.get(e);t&&Common.EventTarget.removeEventListeners(t)}async#O(e){const t=`\n      ${await Util.InjectedScript.get()};DevToolsRecorder.startRecording({getAccessibleName, getAccessibleRole}, {\n        debug: ${Util.isDebugBuild},\n        allowUntrustedEvents: ${RecordingSession.#B},\n        selectorTypesToRecord: ${JSON.stringify(this.#v)},\n        selectorAttribute: ${this.#p.selectorAttribute?formatAsJSLiteral(this.#p.selectorAttribute):void 0},\n        stopShortcuts: ${JSON.stringify(this.#I())},\n      });\n    `,[{identifier:r}]=await Promise.all([e.pageAgent().invoke_addScriptToEvaluateOnNewDocument({source:t,worldName:Util.DEVTOOLS_RECORDER_WORLD_NAME,includeCommandLineAPI:!0}),evaluateInAllFrames(Util.DEVTOOLS_RECORDER_WORLD_NAME,e,t)]);this.#d.set(e.id(),r)}async#_(e){const t=this.#d.get(e.id());t&&(await e.pageAgent().invoke_removeScriptToEvaluateOnNewDocument({identifier:t}),await evaluateInAllTargets(Util.DEVTOOLS_RECORDER_WORLD_NAME,[...this.#i.values()],"DevToolsRecorder.stopRecording()"))}#L(e,t){this.#x({type:"targetCreated",event:t,target:e})}#K(e,t){const r=this.#i.get(t.data);r&&this.#x({type:"targetClosed",event:t,target:r})}#P(e,t){const r=this.#i.get(t.data.targetId)||e;this.#x({type:"targetInfoChanged",event:t,target:r})}#x(e){return this.#c.run((async()=>{try{switch(Util.isDebugBuild&&console.time(`Processing ${JSON.stringify(e)}`),e.type){case"targetClosed":await this.#W(e);break;case"targetCreated":await this.#J(e);break;case"targetInfoChanged":await this.#$(e)}Util.isDebugBuild&&console.timeEnd(`Processing ${JSON.stringify(e)}`)}catch(e){console.error("Error happened while processing recording events: ",e.message,e.stack)}}))}async#J(e){if("page"!==e.event.data.type&&"iframe"!==e.event.data.type)return;await this.#r.invoke_attachToTarget({targetId:e.event.data.targetId,flatten:!0});const t=SDK.TargetManager.TargetManager.instance().targets().find((t=>t.id()===e.event.data.targetId));if(!t)throw new Error("Could not find target.");await this.#w(t),window.dispatchEvent(new Event("recorderAttachedToTarget"))}async#W(e){const t=this.#h.get(e.target.id());t&&(delete t.assertedEvents,this.#h.delete(e.target.id()))}async#V(e,t){const r=await e.navigationHistory();if(!r)return!1;const a=r.entries[r.currentIndex];if(this.#n.get(t.id())===a.id)return!0;this.#n.set(t.id(),a.id);const s=this.#o.get(t.id())||[];if(this.#o.set(t.id(),r.entries.map((e=>e.id))),unrelatedNavigationTypes.has(a.transitionType)||s.includes(a.id)){const e=this.#h.get(t.id());e&&(delete e.assertedEvents,this.#h.delete(t.id())),this.#S({type:StepType.Navigate,url:a.url,assertedEvents:[{type:AssertedEventType.Navigation,url:a.url,title:a.title}]})}else this.#A(t,{type:AssertedEventType.Navigation,url:a.url,title:a.title});return!0}async#$(e){if("page"!==e.event.data.type&&"iframe"!==e.event.data.type)return;const t=e.target,r=t.model(SDK.ResourceTreeModel.ResourceTreeModel);if(!r)throw new Error("ResourceTreeModel is missing in handleNavigation");if("iframe"===e.event.data.type)this.#A(t,{type:AssertedEventType.Navigation,url:e.event.data.url,title:await this.#E(t)});else if("page"===e.event.data.type){if(await this.#V(r,t))return;await this.#H(r,500),this.#A(t,{type:AssertedEventType.Navigation,url:e.event.data.url,title:await this.#E(t)})}}async#H(e,t){let r=()=>Promise.resolve();const a=new Promise((e=>{r=e})),s=()=>{e.removeEventListener(SDK.ResourceTreeModel.Events.DOMContentLoaded,s),r()};e.addEventListener(SDK.ResourceTreeModel.Events.DOMContentLoaded,s),await Promise.any([a,new Promise((r=>setTimeout((()=>{e.removeEventListener(SDK.ResourceTreeModel.Events.DOMContentLoaded,s),r()}),t)))])}}