import{assert}from"../util/assert.js";import{addEventListener,debugError,PuppeteerURL,removeEventListeners}from"./util.js";export class Coverage{#e;#t;constructor(e){this.#e=new JSCoverage(e),this.#t=new CSSCoverage(e)}async startJSCoverage(e={}){return await this.#e.start(e)}async stopJSCoverage(){return await this.#e.stop()}async startCSSCoverage(e={}){return await this.#t.start(e)}async stopCSSCoverage(){return await this.#t.stop()}}export class JSCoverage{#s;#r=!1;#n=new Map;#i=new Map;#o=[];#a=!1;#c=!1;#l=!1;constructor(e){this.#s=e}async start(e={}){assert(!this.#r,"JSCoverage is already enabled");const{resetOnNavigation:t=!0,reportAnonymousScripts:s=!1,includeRawScriptCoverage:r=!1,useBlockCoverage:n=!0}=e;this.#a=t,this.#c=s,this.#l=r,this.#r=!0,this.#n.clear(),this.#i.clear(),this.#o=[addEventListener(this.#s,"Debugger.scriptParsed",this.#h.bind(this)),addEventListener(this.#s,"Runtime.executionContextsCleared",this.#d.bind(this))],await Promise.all([this.#s.send("Profiler.enable"),this.#s.send("Profiler.startPreciseCoverage",{callCount:this.#l,detailed:n}),this.#s.send("Debugger.enable"),this.#s.send("Debugger.setSkipAllPauses",{skip:!0})])}#d(){this.#a&&(this.#n.clear(),this.#i.clear())}async#h(e){if(!PuppeteerURL.isPuppeteerURL(e.url)&&(e.url||this.#c))try{const t=await this.#s.send("Debugger.getScriptSource",{scriptId:e.scriptId});this.#n.set(e.scriptId,e.url),this.#i.set(e.scriptId,t.scriptSource)}catch(e){debugError(e)}}async stop(){assert(this.#r,"JSCoverage is not enabled"),this.#r=!1;const e=await Promise.all([this.#s.send("Profiler.takePreciseCoverage"),this.#s.send("Profiler.stopPreciseCoverage"),this.#s.send("Profiler.disable"),this.#s.send("Debugger.disable")]);removeEventListeners(this.#o);const t=[],s=e[0];for(const e of s.result){let s=this.#n.get(e.scriptId);!s&&this.#c&&(s="debugger://VM"+e.scriptId);const r=this.#i.get(e.scriptId);if(void 0===r||void 0===s)continue;const n=[];for(const t of e.functions)n.push(...t.ranges);const i=convertToDisjointRanges(n);this.#l?t.push({url:s,ranges:i,text:r,rawScriptCoverage:e}):t.push({url:s,ranges:i,text:r})}return t}}export class CSSCoverage{#s;#r=!1;#u=new Map;#g=new Map;#o=[];#a=!1;constructor(e){this.#s=e}async start(e={}){assert(!this.#r,"CSSCoverage is already enabled");const{resetOnNavigation:t=!0}=e;this.#a=t,this.#r=!0,this.#u.clear(),this.#g.clear(),this.#o=[addEventListener(this.#s,"CSS.styleSheetAdded",this.#p.bind(this)),addEventListener(this.#s,"Runtime.executionContextsCleared",this.#d.bind(this))],await Promise.all([this.#s.send("DOM.enable"),this.#s.send("CSS.enable"),this.#s.send("CSS.startRuleUsageTracking")])}#d(){this.#a&&(this.#u.clear(),this.#g.clear())}async#p(e){const t=e.header;if(t.sourceURL)try{const e=await this.#s.send("CSS.getStyleSheetText",{styleSheetId:t.styleSheetId});this.#u.set(t.styleSheetId,t.sourceURL),this.#g.set(t.styleSheetId,e.text)}catch(e){debugError(e)}}async stop(){assert(this.#r,"CSSCoverage is not enabled"),this.#r=!1;const e=await this.#s.send("CSS.stopRuleUsageTracking");await Promise.all([this.#s.send("CSS.disable"),this.#s.send("DOM.disable")]),removeEventListeners(this.#o);const t=new Map;for(const s of e.ruleUsage){let e=t.get(s.styleSheetId);e||(e=[],t.set(s.styleSheetId,e)),e.push({startOffset:s.startOffset,endOffset:s.endOffset,count:s.used?1:0})}const s=[];for(const e of this.#u.keys()){const r=this.#u.get(e);assert(void 0!==r,`Stylesheet URL is undefined (styleSheetId=${e})`);const n=this.#g.get(e);assert(void 0!==n,`Stylesheet text is undefined (styleSheetId=${e})`);const i=convertToDisjointRanges(t.get(e)||[]);s.push({url:r,ranges:i,text:n})}return s}}function convertToDisjointRanges(e){const t=[];for(const s of e)t.push({offset:s.startOffset,type:0,range:s}),t.push({offset:s.endOffset,type:1,range:s});t.sort(((e,t)=>{if(e.offset!==t.offset)return e.offset-t.offset;if(e.type!==t.type)return t.type-e.type;const s=e.range.endOffset-e.range.startOffset,r=t.range.endOffset-t.range.startOffset;return 0===e.type?r-s:s-r}));const s=[],r=[];let n=0;for(const e of t){if(s.length&&n<e.offset&&s[s.length-1]>0){const t=r[r.length-1];t&&t.end===n?t.end=e.offset:r.push({start:n,end:e.offset})}n=e.offset,0===e.type?s.push(e.range.count):s.pop()}return r.filter((e=>e.end-e.start>0))}